package com.dzeio.charts.series

import android.graphics.Canvas
import android.graphics.RectF
import com.dzeio.charts.ChartView
import com.dzeio.charts.Entry
import kotlin.math.min

abstract class SerieAbstract {

    var datas: ArrayList<Entry> = arrayListOf()

    lateinit var view: ChartView

    fun getYMax(displayedOnly: Boolean = false): Float {
        var max = 0f
        var localDatas = if (displayedOnly) datas.subList(
            view.getXOffset(),
            min(view.getXOffset() + view.getDisplayedEntries(), datas.size)
        ) else datas
        for (data in localDatas) {
            if (max < data.y) max= data.y
        }
        return max
    }

    /**
     * Animation updates
     */
    abstract fun onUpdate(): Boolean

    /**
     * Function to prepare for an update
     */
    abstract fun prepareData()

    /**
     * Function to display data on the graph
     *
     * @param canvas the canvas to draw on
     * @param rect the rectangle in which you have to draw data
     */
    abstract fun displayData(canvas: Canvas, rect: RectF)
}
